Layer rendering order broken in QGIS 3x

2018-04-04 11:42 AM - Andreas Neumann

Status: Closed

Priority: High

Assignee: Alessandro Pasotti

Category: Symbology

Affected QGIS version:3.1(master) Regression?: Yes

Operating System: Easy fix?: Yes

Pull Request or Patch supplied:Yes Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 26508

Description

The alternative layer order (see separate "Layer Order Panel") is broken in QGIS 3 when opening a 2.18 project file.

This is not such a well-known, but very powerful feature - one can deliberately reorganize the rendering order in the separate "Layer

Order" panel. This is necessary for more complex cartographic output (e.g. cadastral maps).

I noticed that an existing 2.18 qgs project opened in 3.0 does two bad things:

1. the checkbox "Control rendering order" in the "Layer Order" panel is set to "off" in QGIS 3, whereas it was on in 2.18

2. the ordering in the Layer Order panel is completeley mixed up (not as it was in 2.18).

I think that this a very important issue to fix for any serious cartographic output involving many layers.

I can provide sample data and project.

Associated revisions

Revision 958cb3dd - 2018-04-05 11:41 AM - Alessandro Pasotti 

[bugfix] Layer rendering order broken in QGIS 3x

Fixes #18620

Revision ca732051 - 2018-04-05 12:09 PM - Alessandro Pasotti 

[bugfix] Layer rendering order broken in QGIS 3x

Fixes #18620

Cherry-picked from master 958cb3dd15d2

Revision 222977f2 - 2018-04-06 07:55 AM - Nyall Dawson

Add unit tests for loading projects with custom layer order

Refs #18620
Revision 7978bfd8 - 2018-04-09 06:37 AM - Nyall Dawson

Add unit tests for loading projects with custom layer order

Refs #18620

(cherry-picked from 222977f)

History

#1 - 2018-04-04 11:51 AM - Andreas Neumann

- File layer_rendering_order_issue_qgis3.qgs added

#2 - 2018-04-04 11:52 AM - Andreas Neumann

- File layer_rendering_order_garbled_2.png added

#3 - 2018-04-05 11:26 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#4 - 2018-04-05 11:43 AM - Alessandro Pasotti

- Easy fix? changed from No to Yes

- Pull Request or Patch supplied changed from No to Yes

- Status changed from Open to In Progress

PR https://github.com/qgis/QGIS/pull/6751

#5 - 2018-04-05 12:08 PM - Anonymous

- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Applied in changeset commit:qgis|958cb3dd15d22982be90def638d6e871ecbe8e69.

#6 - 2018-04-05 12:10 PM - Alessandro Pasotti

- Resolution set to fixed/implemented

#7 - 2018-04-05 01:01 PM - Andreas Neumann

Thanks,  @elpaso ! - will test with tomorrow's nightly.

#8 - 2018-04-05 02:27 PM - Andreas Neumann

Just tested with self-compiled version (master) and the issue seems to be fixed. Many thanks!

#9 - 2018-04-05 02:41 PM - Alessandro Pasotti

You're welcome! This was a low hanging fruit.
